#ifndef ENEMY_HPP
#define ENEMY_HPP

#include "Object.hpp"

class Enemy : public Object
{
public:
	enum
	{
		PHASE_WAIT = 0,
		PHASE_MOVE,
		PHASE_ATTACK,
		PHASE_WAIT_MOVE,
		AI_TYPE0 = 0, // HɌ߂
		AI_TYPE1, // i^Cv
		AI_TYPE2, // 낤^Cv
		AI_TYPE3, // Hǂ
		AI_TYPE4, // 낤ǂ
	};
	Enemy(void);
	~Enemy(void);
	void SetAIType(int ai_type);
	virtual void Update(void);
	void Attack(int damage);
	int GetPhase(void);
	void EnableMove(void);
	int CalcParameter(int min, int max, int floor);
	int GetDropCrystal(void);
	int GetStatusUpType(void);
private:
	int GetPlayerDirection(void);
	virtual void MoveAI(void);
	Enemy(Enemy&);
	Enemy& operator = (Enemy&);
protected:
	int phase;
	int move_count;
	bool attacked;
	int ai_type;
	int drop_crystal;
	bool status_up;
};

#endif
