#ifndef ITEM_HPP
#define ITEM_HPP

class Item
{
public:
	enum
	{
		NONE = 0,
		POTION,
		SEED,
		HEART,
		CRYSTAL,
		POT,
		BOOK,
		LONG_SWORD,
		SHORT_SWORD,
		KATANA,
		AX,
		SPEAR,
		MORNING_STAR,
		WAND,
		WIZARD_WAND,
		CRYSTAL_WAND,
		BOW,
		WHIP,
		THROWING_STAR,
		THROWING_KNIVES,
		LOCK,
		SCROLL,
		ID_MAX,
		TYPE_IMMEDIATE_USE = 0,
		TYPE_IMMEDIATE_TAKE,
		TYPE_EQUIPMENT,
		ATTRIBUTE_NONE = 0,
		ATTRIBUTE_WARRIOR = 0x1,
		ATTRIBUTE_WIZARD = 0x2,
		ATTRIBUTE_PRIEST = 0x4,
		ATTRIBUTE_NINJA = 0x8,
		ATTRIBUTE_ALL = 0xFFFFFFFF,
	};
	struct Data
	{
		int type; // ACe^Cv
		const char* name; // ACe
		int attack; // ACeƂĂ̍U
		int hp; // ACeƂĂHP
		int recovery; // gp̉񕜗
		unsigned int attribute; // gpłE
		int image_x; // 摜ʒu
		int image_y; // 摜ʒu
	};
	Item(void);
	~Item(void);
	void Draw(int x, int y);
	void LotteryTreasure(int floor, int player_type);
	void Get(int& id, int& grade);
	void Set(int id, int grade, int bonus_dcy);
	int GetID(void);
	int GetGrade(void);
	int GetType(void);
	const char* GetName(void);
	int GetAttack(void);
	void SetDcy(int dcy);
	int GetDcy(void);
	void SetAddDcy(int add_dcy);
	int GetAddDcy(void);
	bool Use(void);
	unsigned int GetAttribute(void);
	int GetRecovery(void);
private:
	static const Data* GetData(int id);
	static int DrawTreasure(int floor);
	int id; // ACe̎
	int grade; // ACẽO[h
	int dcy;
	int add_dcy;
	Item(Item&);
	Item& operator = (Item&);
};

#endif
